/*
 * emulation.cpp
 *
 * the embodiment of an emulation in progress
 */

/* $Id: emulation.cpp,v 1.1 2000/05/29 23:55:12 nyef Exp $ */

#include "emulation.h"

extern "C" {
#include "ui.h"
}

/* #define THREAD_PRIORITY B_URGENT_DISPLAY_PRIORITY */
#define THREAD_PRIORITY B_NORMAL_PRIORITY

emulation::emulation(int system_type, rom_file romfile)
{
    this->system_type = system_type;
    this->romfile = romfile;
    this->active = 0;
}

int32 emulation_mainloop(void *data)
{
    return ((emulation *)data)->mainloop();
}

void emulation::start()
{
    active = 1;

    thread = spawn_thread(emulation_mainloop, "DarcNES/emulating", THREAD_PRIORITY, this);

    resume_thread(thread);
}

void emulation::stop()
{
    status_t result;

    if (active) {
	active = 0;
	wait_for_thread(thread, &result);
    }
}


/* emulation timeslicing */

void (*timeslice)(void *) = NULL;
void *timeslice_data;
shutdown_t dn_shutdown;

void set_timeslice(void (*proc)(void *), void *data)
{
    timeslice = proc;
    timeslice_data = data;
}

void unset_timeslice(void)
{
    timeslice = NULL;
    timeslice_data = NULL;
}

int32 emulation::mainloop()
{
    activate_system(system_type, romfile);

    if (!timeslice) {
	/* FIXME: Scream bloody murder */
    }

    while (active) {
	timeslice(timeslice_data);

	if (system_flags != F_NONE) {
	    active = 0;
	}
    }

    if (dn_shutdown) {
	dn_shutdown();
    }

    return 0;
}


/*
 * $Log: emulation.cpp,v $
 * Revision 1.1  2000/05/29 23:55:12  nyef
 * Initial revision
 *
 */
